%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                                      %%
%%  ClientServer tool: Client2.oz example                               %%
%%                                                                      %%
%%  (c) 2000 Universit catholique de Louvain.  All Rights Reserved.    %%
%%  The development of ClientServer is supported by the PIRATES project %%
%%  at the Universit catholique de Louvain.  This file is subject to   %%
%%  the general Mozart license.                                         %%
%%                                                                      %%
%%  Author: Peter Van Roy                                               %%
%%                                                                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

functor
import Application QTk
export query:Q
define
   Q
thread
   In Out H
   D=td(title:"Oz super expression evaluator"
        tdrubberframe(glue:nswe
          lr(glue:nswe
             label(text:"Expression")
             text(handle:In glue:nswe))
          lr(glue:nswe
             td(label(text:"Result")
                label(text:"DONE" bg:green handle:H))
             text(handle:Out glue:nswe tdscrollbar:true)))
        lr(glue:we
           button(glue:we text:"Eval"
                  action: proc {$}
                          V in
                             try
                                {H set(text:"CALCULATING" bg:red)}
                                V={Q {In get($)}}
                                {Out set(V)}
                             catch _ then
                                {Out set("*** Syntax Error ***")}
                             finally
                                {H set(text:"DONE" bg:green)}
                             end
                          end)
           button(glue:we text:"Quit"
                  action:toplevel#close)))
   W={QTk.build D}
   {W show(wait:true)}
   {Application.exit 0}
in skip end
end
